from gpiozero import PWMLED
import time
import random

# Definition der PWMLEDs für jede Farbe
led_rot = PWMLED(25)
led_gruen = PWMLED(24)
led_blau = PWMLED(23)

# Diese Funktion generiert die eigentliche Farbe
# Mittels der jeweiligen Farbvariable kann die Farbintensität geändert werden
# Nachdem die Farbe eingestellt wurde, wird mittels "time.sleep" die Zeit definiert,
# wie lang die besagte Farbe angezeigt werden soll
def led_farbe(rot, gruen, blau, pause):
    led_rot.value = rot
    led_gruen.value = gruen
    led_blau.value = blau
    time.sleep(pause)

    # Zurücksetzen auf Null nach dem Durchlauf
    led_rot.value = 0
    led_gruen.value = 0
    led_blau.value = 0

print("LED-Test [drücken Sie STRG+C, um den Test zu beenden]")

# Hauptprogrammschleife:
# Diese hat die Aufgabe für jede einzelne Farbe eine eigene Variable zu erstellen
# und mittels einer For-Schleife die Farbintensität jeder einzelnen Farbe von 0-100% zu durchlaufen
# Durch die Mischungen der verschiedenen Helligkeitsstufen der jeweiligen Farben
# entsteht somit ein Farbverlauf
try:
    while True:
        for x in range(0, 2):
            for y in range(0, 2):
                for z in range(0, 2):
                    print(x, y, z)
                    for i in range(0, 101):
                        # Einstellen der LED Farbe basierend auf dem aktuellen Schleifendurchlauf
                        led_farbe(x * i / 100, y * i / 100, z * i / 100, 0.02)

# Aufräumarbeiten, nachdem das Programm beendet wurde
except KeyboardInterrupt:
    print("Programm beendet durch Benutzer")